#The goal is to simulated about as many adult ash as could be in the Allegheny forest- 1.5 million
#and sample from this 500, 1000, etc. and see how many alleles are caught

#First I ran fastsimcoal using the .par files with just one iteration
fastsimcoal -i test.par -n 1 -g -q

#Then used code at the end of this file to convert the .arp to .gen (for some reason the arp2gen function is broken and doesn't understand the population size)

#Made a modified get.allele.cat because just looking at global alleles
#Then ran similar to other ash files
#Note that 100K had 949 alleles existing

get.allele.cat<-function(UK_genpop, n_ind_p_pop){
	allele_freqs<-colSums(UK_genpop@tab)/(n_total_indivs*2)	
	global<-1:length(allele_freqs)
	glob_com<-as.vector(which(allele_freqs>0.10,arr.ind=T))
	glob_lowfr<-as.vector(which(allele_freqs<0.10&allele_freqs>0.01))
	glob_rare<-as.vector(which(allele_freqs<0.01,arr.ind=T))
	list(global,glob_com,glob_lowfr,glob_rare)
}

	Fa_genind<-read.genepop("test/test_1_1.gen",ncode=3)
	Fa_genpop<-genind2genpop(Fa_genind);	Fa_genind_sep<-seppop(Fa_genind)

	list_allele_cat<-c("global","glob_com","glob_lowfr","glob_rare")
		
	num_scen<-1; num_reps<-10; scen<-1
	num_trees<-c(50,100,200,300,400,500,1000,1500,2000,2500,3000,3500,4000,4500,5000)
	summ_results<-array(dim=c(length(num_trees)+1,5+2,num_scen,num_reps))
	type_samp<-c("random")
	
	n_pops<-1;		n_total_indivs<- 25000
	allele_freqs<-colSums(Fa_genpop@tab)/(n_total_indivs*2)	
	
	allele_cat<-get.allele.cat(Fa_genpop, region_makeup)	
	#glob; 	glob_v_com; 	glob_com;	glob_lowfr;		glob_rare
	
	#######################
	#--SUBSAMPLE SECTION--#
	#######################

for (nrep in 1:num_reps){
	for (samp in 1:length(num_trees)){
		alleles<-matrix(nrow=1,ncol=length(allele_freqs))
		alleles<-sample.pop(Fa_genind_sep,1,num_trees[samp])
		
		#record number of pops and number of trees
		summ_results[samp,1:2,scen,nrep]<-c(1,num_trees[samp])
		
		#this will record each time an allele is CAUGHT in one of our sampled populations
		#By summing the columns for alleles, focusing on those in allele cat l, and counting how many are greater than 0
		for (l in 1:length(allele_cat)) summ_results[samp,l+2,scen,nrep] <-sum(colSums(alleles,na.rm=T)[allele_cat[[l]]]>0)
	}
	#this will record the number of alleles that EXISTS for each category in last row
	for(l in 1:length(allele_cat)) summ_results[length(summ_results[,1,1,1]),l+2,scen,nrep]<-length(allele_cat[[l]])
}
	
	for (n in 1:num_reps) summ_results[,3:7,1,n]<-t(t(summ_results[,3:7,1,n])/summ_results[length(summ_results[,1,1,1]),3:7,1,n])	
all_mean<-apply(summ_results[,,1,1:num_reps],c(1,2),mean)

save(summ_results,file="summ_results_million.R"); save(list_pops_sampled,file="list_pops_sampled.R")












 infile<-"test/test_1_1.arp"

     tstfile <- paste(flForm[1], ".gen", sep = "")
  fastScan <- function(fname) {
             s <- file.info(fname)$size
             buf <- readChar(fname, s, useBytes = TRUE)
             if (length(grep("\r", buf)) != 0L) {
                 buf <- gsub("\r", "\n", buf)
                 buf <- gsub("\n\n", "\n", buf)
             }
             return(strsplit(buf, "\n", fixed = TRUE, useBytes = TRUE)[[1]])
         }
  dat <- fastScan(infile)
         dat <- gsub("^\\s+|\\s+$", "", dat)
         dataType <- grep("*datatype=*", tolower(dat))
         if (strsplit(dat[dataType], "=")[[1]][2] != "MICROSAT") {
             stop("Data are not in 'MICROSAT' format!")
         }
         missDataLine <- grep("*missingdata=*", tolower(dat))
         missData <- noquote(substr(dat[missDataLine], nchar(dat[missDataLine]) - 
             1, nchar(dat[missDataLine]) - 1))
         sampSizeLine <- grep("*samplesize=*", tolower(dat))
         if (length(sampSizeLine) > 1) {
             sampNpos <- sapply(sampSizeLine, function(i) {
                 return(regexpr("=", dat[i])[1])
             })
         }
 popSizes <- 250000
         npops <- length(popSizes)
         sampStrt <- grep("*sampledata=*", tolower(dat))
         strts <- sapply(sampStrt, function(x) {
             if (dat[(x + 1)] == "") {
                 return(x + 2)
             }
             else {
                 return(x + 1)
             }
         })
         ends <- strts + ((popSizes * 2) - 1)
         nloci <- length(strsplit(dat[strts[1]], split = "\\s+")[[1]]) - 
             2
         popGeno <- lapply(seq_along(strts), function(i) {
             return(dat[strts[i]:ends[i]])
         })
         popSzcheck <- sapply(popGeno, function(x) length(x)/2)
         if (!all(identical(popSzcheck, popSizes))) {
             stop("Failed! Please make sure that your file is formatted correctly.")
         }
         popIdx <- lapply(popGeno, function(x) {
             return(seq(1, length(x), 2))
         })
         popList <- lapply(seq_along(popGeno), function(i) {
             al1 <- matrix(unlist(strsplit(popGeno[[i]][popIdx[[i]]], 
                 split = "\\s+")), nrow = popSizes[i], byrow = TRUE)[, 
                 -(1:2)]
             al2 <- matrix(unlist(strsplit(popGeno[[i]][(popIdx[[i]] + 
                 1)], split = "\\s+")), nrow = popSizes[i], byrow = TRUE)
             tst <- matrix(paste(al1, al2, sep = ""), nrow = popSizes[i])
             tst <- cbind(paste(rep("pop", nrow(tst)), i, " ,", 
                 sep = ""), tst)
             rm(al1, al2)
             z <- gc()
            rm(z)
             if (nchar(tst[1, 2]) == 4) {
                 tst[tst == paste(missData, missData, sep = "")] <- "0000"
             }
             else {
                 tst[tst == paste(missData, missData, sep = "")] <- "000000"
             }
             out <- apply(tst, 1, function(x) {
                 return(paste(x, collapse = "\t"))
             })
             out <- c("POP", out)
             rm(tst)
             z <- gc()
             rm(z)
             return(out)
         })
         outfile <- strsplit(infile, "\\.")[[1]]
         if (length(outfile) >= 2) {
             outfile <- paste(outfile[-length(outfile)], collapse = ".")
         }
         else {
             outfile <- outfile[1]
         }
         loci <- paste("locus", 1:nloci, sep = "")
         loci <- c(paste(outfile, "_gen_converted", sep = ""), 
             loci)
         of <- c(loci, unlist(popList))
         out <- file(paste(outfile, ".gen", sep = ""), "w")
         for (i in 1:length(of)) {
             cat(of[i], "\n", file = out, sep = "")
         }
         close(out)